Listing 1: fv.c

// James K. Lawless
// 2414 4th Ave
// Council Bluffs, IA 51501
// 74217.531@compuserve.com
// 
// File-viewing program demonstrating the video 
// scrolling capabilities of EGA/VGA video 
// adapters.


#include <stdio.h>
#include <conio.h>

void add_line(char *);
void view_file(void);
unsigned short get_a_key(void);
void set_vid_start(unsigned short);

#define K_ESC      (0x001B)
#define K_HOME     (0x4700)
#define K_END      (0x4F00)
#define K_CRUP     (0x4800)
#define K_CRDN     (0x5000)
#define K_PGUP     (0x4900)
#define K_PGDN     (0x5100)
unsigned short lines=0;
unsigned short cur_line=0;

main(int argc,char **argv)
{
   FILE *fp;    
   char buff[82];

   // Set video mode to 80x25 color
   _asm {
      mov ax,3
      int 10h
   }
  
   if((fp=fopen(argv[1],"r"))==NULL) {
      fprintf(stderr,
         "Cannot open input file %s\n",argv[1]);
      exit(1);
   }
 
   // Pass the file
   while(1) {
      if(!fgets(buff,81,fp))
         break;
      add_line(buff);
   }
   fclose(fp);
 
   view_file();
   set_vid_start(0);
   exit(0);
}


// Insert the specified line into the video buffer.
void add_line(char *s)
{
   static char far *vid=(char far *)0xb8000000L;
   int i;
 
   for(i=0;i<80;i++) {
      if((*s=='\n')||(!*s)) 
         *vid++=' ';
      else
         *vid++=*s++;
      *vid++=0x17;    // Attribute...
   }  
   lines++;
}


// Scroll around the video buffer
void view_file(void)
{
   unsigned short u;
   while(1) {
      u=get_a_key();
      switch(u) {
         case K_ESC:
            return;
 
         case K_CRDN:
            if(cur_line<(lines-25)) {
               cur_line++;
            }
            break;

         case K_CRUP:
            if(cur_line!=0) {
               cur_line--;
            }
            break;

         case K_PGDN:
            cur_line+=25;
            if(cur_line>(lines-25)) {
               cur_line=lines-25;
            }
            break;

         case K_PGUP:
            if(cur_line<25) {
               cur_line=0;
            }
            else
               cur_line-=25;
            break;

         case K_HOME:
            cur_line=0;
            break;
   
         case K_END:
            cur_line=lines-25;
            break;

      }
      set_vid_start(cur_line);            
   }
}


// Get a keystroke, with extended key support
unsigned short get_a_key(void)
{
   unsigned short u;
   u=getch();
   if(!u)
      u=(getch())<<8;
   return(u);
}

// Set the starting offset of the video buffer.
void set_vid_start(unsigned short line)
{

   // Set high-order byte of the start-address
   // The register index is 0x0c
   outp(0x3d4,0x0c);
   outp(0x3d5,(line * 80) >> 8 );

   // Set low-order byte of the start-address
   // The register index is 0x0d
   outp(0x3d4,0x0d);
   outp(0x3d5,(line * 80 ) & 0xff );
}
